dpkg-maintscript-helper.sh 17 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591592593594595596597598599600
  1. #!/bin/sh
  2. #
  3. # Copyright © 2007,2011-2013 Guillem Jover <guillem@debian.org>
  4. # Copyright © 2010 Raphaël Hertzog <hertzog@debian.org>
  5. # Copyright © 2008 Joey Hess <joeyh@debian.org>
  6. # Copyright © 2005 Scott James Remnant (original implementation on www.dpkg.org)
  7. #
  8. # This program is free software; you can redistribute it and/or modify
  9. # it under the terms of the GNU General Public License as published by
  10. # the Free Software Foundation; either version 2 of the License, or
  11. # (at your option) any later version.
  12. #
  13. # This program is distributed in the hope that it will be useful,
  14. # but WITHOUT ANY WARRANTY; without even the implied warranty of
  15. # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  16. # GNU General Public License for more details.
  17. #
  18. # You should have received a copy of the GNU General Public License
  19. # along with this program. If not, see <https://www.gnu.org/licenses/>.
  20. # The conffile related functions are inspired by
  21. # https://wiki.debian.org/DpkgConffileHandling
  22. # This script is documented in dpkg-maintscript-helper(1)
  23. ##
  24. ## Functions to remove an obsolete conffile during upgrade
  25. ##
  26. rm_conffile() {
  27. local CONFFILE="$1"
  28. local LASTVERSION="$2"
  29. local PACKAGE="$3"
  30. if [ "$LASTVERSION" = "--" ]; then
  31. LASTVERSION=""
  32. PACKAGE="$DPKG_MAINTSCRIPT_PACKAGE${DPKG_MAINTSCRIPT_ARCH:+:$DPKG_MAINTSCRIPT_ARCH}"
  33. fi
  34. if [ "$PACKAGE" = "--" -o -z "$PACKAGE" ]; then
  35. PACKAGE="$DPKG_MAINTSCRIPT_PACKAGE${DPKG_MAINTSCRIPT_ARCH:+:$DPKG_MAINTSCRIPT_ARCH}"
  36. fi
  37. # Skip remaining parameters up to --
  38. while [ "$1" != "--" -a $# -gt 0 ]; do shift; done
  39. [ $# -gt 0 ] || badusage "missing arguments after --"
  40. shift
  41. [ -n "$PACKAGE" ] || error "couldn't identify the package"
  42. [ -n "$1" ] || error "maintainer script parameters are missing"
  43. [ -n "$DPKG_MAINTSCRIPT_NAME" ] || \
  44. error "environment variable DPKG_MAINTSCRIPT_NAME is required"
  45. debug "Executing $0 rm_conffile in $DPKG_MAINTSCRIPT_NAME" \
  46. "of $DPKG_MAINTSCRIPT_PACKAGE"
  47. debug "CONFFILE=$CONFFILE PACKAGE=$PACKAGE" \
  48. "LASTVERSION=$LASTVERSION ACTION=$1 PARAM=$2"
  49. case "$DPKG_MAINTSCRIPT_NAME" in
  50. preinst)
  51. if [ "$1" = "install" -o "$1" = "upgrade" ] && [ -n "$2" ] &&
  52. dpkg --compare-versions "$2" le-nl "$LASTVERSION"; then
  53. prepare_rm_conffile "$CONFFILE" "$PACKAGE"
  54. fi
  55. ;;
  56. postinst)
  57. if [ "$1" = "configure" ] && [ -n "$2" ] &&
  58. dpkg --compare-versions "$2" le-nl "$LASTVERSION"; then
  59. finish_rm_conffile "$CONFFILE"
  60. fi
  61. ;;
  62. postrm)
  63. if [ "$1" = "purge" ]; then
  64. rm -f "$CONFFILE.dpkg-bak" "$CONFFILE.dpkg-remove" \
  65. "$CONFFILE.dpkg-backup"
  66. fi
  67. if [ "$1" = "abort-install" -o "$1" = "abort-upgrade" ] &&
  68. [ -n "$2" ] &&
  69. dpkg --compare-versions "$2" le-nl "$LASTVERSION"; then
  70. abort_rm_conffile "$CONFFILE" "$PACKAGE"
  71. fi
  72. ;;
  73. *)
  74. debug "$0 rm_conffile not required in $DPKG_MAINTSCRIPT_NAME"
  75. ;;
  76. esac
  77. }
  78. prepare_rm_conffile() {
  79. local CONFFILE="$1"
  80. local PACKAGE="$2"
  81. [ -e "$CONFFILE" ] || return 0
  82. ensure_package_owns_file "$PACKAGE" "$CONFFILE" || return 0
  83. local md5sum="$(md5sum $CONFFILE | sed -e 's/ .*//')"
  84. local old_md5sum="$(dpkg-query -W -f='${Conffiles}' $PACKAGE | \
  85. sed -n -e "\' $CONFFILE ' { s/ obsolete$//; s/.* //; p }")"
  86. if [ "$md5sum" != "$old_md5sum" ]; then
  87. mv -f "$CONFFILE" "$CONFFILE.dpkg-backup"
  88. else
  89. mv -f "$CONFFILE" "$CONFFILE.dpkg-remove"
  90. fi
  91. }
  92. finish_rm_conffile() {
  93. local CONFFILE="$1"
  94. if [ -e "$CONFFILE.dpkg-backup" ]; then
  95. echo "Obsolete conffile $CONFFILE has been modified by you."
  96. echo "Saving as $CONFFILE.dpkg-bak ..."
  97. mv -f "$CONFFILE.dpkg-backup" "$CONFFILE.dpkg-bak"
  98. fi
  99. if [ -e "$CONFFILE.dpkg-remove" ]; then
  100. echo "Removing obsolete conffile $CONFFILE ..."
  101. rm -f "$CONFFILE.dpkg-remove"
  102. fi
  103. }
  104. abort_rm_conffile() {
  105. local CONFFILE="$1"
  106. local PACKAGE="$2"
  107. ensure_package_owns_file "$PACKAGE" "$CONFFILE" || return 0
  108. if [ -e "$CONFFILE.dpkg-remove" ]; then
  109. echo "Reinstalling $CONFFILE that was moved away"
  110. mv "$CONFFILE.dpkg-remove" "$CONFFILE"
  111. fi
  112. if [ -e "$CONFFILE.dpkg-backup" ]; then
  113. echo "Reinstalling $CONFFILE that was backupped"
  114. mv "$CONFFILE.dpkg-backup" "$CONFFILE"
  115. fi
  116. }
  117. ##
  118. ## Functions to rename a conffile during upgrade
  119. ##
  120. mv_conffile() {
  121. local OLDCONFFILE="$1"
  122. local NEWCONFFILE="$2"
  123. local LASTVERSION="$3"
  124. local PACKAGE="$4"
  125. if [ "$LASTVERSION" = "--" ]; then
  126. LASTVERSION=""
  127. PACKAGE="$DPKG_MAINTSCRIPT_PACKAGE${DPKG_MAINTSCRIPT_ARCH:+:$DPKG_MAINTSCRIPT_ARCH}"
  128. fi
  129. if [ "$PACKAGE" = "--" -o -z "$PACKAGE" ]; then
  130. PACKAGE="$DPKG_MAINTSCRIPT_PACKAGE${DPKG_MAINTSCRIPT_ARCH:+:$DPKG_MAINTSCRIPT_ARCH}"
  131. fi
  132. # Skip remaining parameters up to --
  133. while [ "$1" != "--" -a $# -gt 0 ]; do shift; done
  134. [ $# -gt 0 ] || badusage "missing arguments after --"
  135. shift
  136. [ -n "$PACKAGE" ] || error "couldn't identify the package"
  137. [ -n "$1" ] || error "maintainer script parameters are missing"
  138. [ -n "$DPKG_MAINTSCRIPT_NAME" ] || \
  139. error "environment variable DPKG_MAINTSCRIPT_NAME is required"
  140. debug "Executing $0 mv_conffile in $DPKG_MAINTSCRIPT_NAME" \
  141. "of $DPKG_MAINTSCRIPT_PACKAGE"
  142. debug "CONFFILE=$OLDCONFFILE -> $NEWCONFFILE PACKAGE=$PACKAGE" \
  143. "LASTVERSION=$LASTVERSION ACTION=$1 PARAM=$2"
  144. case "$DPKG_MAINTSCRIPT_NAME" in
  145. preinst)
  146. if [ "$1" = "install" -o "$1" = "upgrade" ] && [ -n "$2" ] &&
  147. dpkg --compare-versions "$2" le-nl "$LASTVERSION"; then
  148. prepare_mv_conffile "$OLDCONFFILE" "$PACKAGE"
  149. fi
  150. ;;
  151. postinst)
  152. if [ "$1" = "configure" ] && [ -n "$2" ] &&
  153. dpkg --compare-versions "$2" le-nl "$LASTVERSION"; then
  154. finish_mv_conffile "$OLDCONFFILE" "$NEWCONFFILE" "$PACKAGE"
  155. fi
  156. ;;
  157. postrm)
  158. if [ "$1" = "abort-install" -o "$1" = "abort-upgrade" ] &&
  159. [ -n "$2" ] &&
  160. dpkg --compare-versions "$2" le-nl "$LASTVERSION"; then
  161. abort_mv_conffile "$OLDCONFFILE" "$PACKAGE"
  162. fi
  163. ;;
  164. *)
  165. debug "$0 mv_conffile not required in $DPKG_MAINTSCRIPT_NAME"
  166. ;;
  167. esac
  168. }
  169. prepare_mv_conffile() {
  170. local CONFFILE="$1"
  171. local PACKAGE="$2"
  172. [ -e "$CONFFILE" ] || return 0
  173. ensure_package_owns_file "$PACKAGE" "$CONFFILE" || return 0
  174. local md5sum="$(md5sum $CONFFILE | sed -e 's/ .*//')"
  175. local old_md5sum="$(dpkg-query -W -f='${Conffiles}' $PACKAGE | \
  176. sed -n -e "\' $CONFFILE ' { s/ obsolete$//; s/.* //; p }")"
  177. if [ "$md5sum" = "$old_md5sum" ]; then
  178. mv -f "$CONFFILE" "$CONFFILE.dpkg-remove"
  179. fi
  180. }
  181. finish_mv_conffile() {
  182. local OLDCONFFILE="$1"
  183. local NEWCONFFILE="$2"
  184. local PACKAGE="$3"
  185. rm -f $OLDCONFFILE.dpkg-remove
  186. [ -e "$OLDCONFFILE" ] || return 0
  187. ensure_package_owns_file "$PACKAGE" "$OLDCONFFILE" || return 0
  188. echo "Preserving user changes to $NEWCONFFILE (renamed from $OLDCONFFILE)..."
  189. mv -f "$NEWCONFFILE" "$NEWCONFFILE.dpkg-new"
  190. mv -f "$OLDCONFFILE" "$NEWCONFFILE"
  191. }
  192. abort_mv_conffile() {
  193. local CONFFILE="$1"
  194. local PACKAGE="$2"
  195. ensure_package_owns_file "$PACKAGE" "$CONFFILE" || return 0
  196. if [ -e "$CONFFILE.dpkg-remove" ]; then
  197. echo "Reinstalling $CONFFILE that was moved away"
  198. mv "$CONFFILE.dpkg-remove" "$CONFFILE"
  199. fi
  200. }
  201. ##
  202. ## Functions to replace a symlink with a directory
  203. ##
  204. symlink_to_dir() {
  205. local SYMLINK="$1"
  206. local SYMLINK_TARGET="$2"
  207. local LASTVERSION="$3"
  208. local PACKAGE="$4"
  209. if [ "$LASTVERSION" = "--" ]; then
  210. LASTVERSION=""
  211. PACKAGE="$DPKG_MAINTSCRIPT_PACKAGE${DPKG_MAINTSCRIPT_ARCH:+:$DPKG_MAINTSCRIPT_ARCH}"
  212. fi
  213. if [ "$PACKAGE" = "--" -o -z "$PACKAGE" ]; then
  214. PACKAGE="$DPKG_MAINTSCRIPT_PACKAGE${DPKG_MAINTSCRIPT_ARCH:+:$DPKG_MAINTSCRIPT_ARCH}"
  215. fi
  216. # Skip remaining parameters up to --
  217. while [ "$1" != "--" -a $# -gt 0 ]; do shift; done
  218. [ $# -gt 0 ] || badusage "missing arguments after --"
  219. shift
  220. [ -n "$DPKG_MAINTSCRIPT_NAME" ] || \
  221. error "environment variable DPKG_MAINTSCRIPT_NAME is required"
  222. [ -n "$PACKAGE" ] || error "cannot identify the package"
  223. [ -n "$SYMLINK" ] || error "symlink parameter is missing"
  224. [ "${SYMLINK#/}" = "$SYMLINK" ] && \
  225. error "symlink pathname is not an absolute path"
  226. [ -n "$SYMLINK_TARGET" ] || error "original symlink target is missing"
  227. [ -n "$1" ] || error "maintainer script parameters are missing"
  228. debug "Executing $0 symlink_to_dir in $DPKG_MAINTSCRIPT_NAME" \
  229. "of $DPKG_MAINTSCRIPT_PACKAGE"
  230. debug "SYMLINK=$SYMLINK -> $SYMLINK_TARGET PACKAGE=$PACKAGE" \
  231. "LASTVERSION=$LASTVERSION ACTION=$1 PARAM=$2"
  232. case "$DPKG_MAINTSCRIPT_NAME" in
  233. preinst)
  234. if [ "$1" = "install" -o "$1" = "upgrade" ] &&
  235. [ -n "$2" ] && [ -h "$SYMLINK" ] &&
  236. symlink_match "$SYMLINK" "$SYMLINK_TARGET" &&
  237. dpkg --compare-versions "$2" le-nl "$LASTVERSION"; then
  238. mv -f "$SYMLINK" "${SYMLINK}.dpkg-backup"
  239. fi
  240. ;;
  241. postinst)
  242. # We cannot bail depending on the version, as here we only
  243. # know what was the last configured version, and we might
  244. # have been unpacked, then upgraded with an unpack and thus
  245. # never been configured before.
  246. if [ "$1" = "configure" ] && [ -h "${SYMLINK}.dpkg-backup" ] &&
  247. symlink_match "${SYMLINK}.dpkg-backup" "$SYMLINK_TARGET"
  248. then
  249. rm -f "${SYMLINK}.dpkg-backup"
  250. fi
  251. ;;
  252. postrm)
  253. if [ "$1" = "purge" ] && [ -h "${SYMLINK}.dpkg-backup" ]; then
  254. rm -f "${SYMLINK}.dpkg-backup"
  255. fi
  256. if [ "$1" = "abort-install" -o "$1" = "abort-upgrade" ] &&
  257. [ -n "$2" ] &&
  258. [ ! -e "$SYMLINK" ] && [ -h "${SYMLINK}.dpkg-backup" ] &&
  259. symlink_match "${SYMLINK}.dpkg-backup" "$SYMLINK_TARGET" &&
  260. dpkg --compare-versions "$2" le-nl "$LASTVERSION"; then
  261. echo "Restoring backup of $SYMLINK ..."
  262. mv "${SYMLINK}.dpkg-backup" "$SYMLINK"
  263. fi
  264. ;;
  265. *)
  266. debug "$0 symlink_to_dir not required in $DPKG_MAINTSCRIPT_NAME"
  267. ;;
  268. esac
  269. }
  270. ##
  271. ## Functions to replace a directory with a symlink
  272. ##
  273. dir_to_symlink() {
  274. local PATHNAME="$1"
  275. local SYMLINK_TARGET="$2"
  276. local LASTVERSION="$3"
  277. local PACKAGE="$4"
  278. if [ "$LASTVERSION" = "--" ]; then
  279. LASTVERSION=""
  280. PACKAGE="$DPKG_MAINTSCRIPT_PACKAGE${DPKG_MAINTSCRIPT_ARCH:+:$DPKG_MAINTSCRIPT_ARCH}"
  281. fi
  282. if [ "$PACKAGE" = "--" -o -z "$PACKAGE" ]; then
  283. PACKAGE="$DPKG_MAINTSCRIPT_PACKAGE${DPKG_MAINTSCRIPT_ARCH:+:$DPKG_MAINTSCRIPT_ARCH}"
  284. fi
  285. # Skip remaining parameters up to --
  286. while [ "$1" != "--" -a $# -gt 0 ]; do shift; done
  287. [ $# -gt 0 ] || badusage "missing arguments after --"
  288. shift
  289. [ -n "$DPKG_MAINTSCRIPT_NAME" ] || \
  290. error "environment variable DPKG_MAINTSCRIPT_NAME is required"
  291. [ -n "$PACKAGE" ] || error "cannot identify the package"
  292. [ -n "$PATHNAME" ] || error "directory parameter is missing"
  293. [ "${PATHNAME#/}" = "$PATHNAME" ] && \
  294. error "directory parameter is not an absolute path"
  295. [ -n "$SYMLINK_TARGET" ] || error "new symlink target is missing"
  296. [ -n "$1" ] || error "maintainer script parameters are missing"
  297. debug "Executing $0 dir_to_symlink in $DPKG_MAINTSCRIPT_NAME" \
  298. "of $DPKG_MAINTSCRIPT_PACKAGE"
  299. debug "PATHNAME=$PATHNAME SYMLINK_TARGET=$SYMLINK_TARGET" \
  300. "PACKAGE=$PACKAGE LASTVERSION=$LASTVERSION ACTION=$1 PARAM=$2"
  301. case "$DPKG_MAINTSCRIPT_NAME" in
  302. preinst)
  303. if [ "$1" = "install" -o "$1" = "upgrade" ] &&
  304. [ -n "$2" ] &&
  305. [ ! -h "$PATHNAME" ] && [ -d "$PATHNAME" ] &&
  306. dpkg --compare-versions "$2" le-nl "$LASTVERSION"; then
  307. prepare_dir_to_symlink "$PACKAGE" "$PATHNAME"
  308. fi
  309. ;;
  310. postinst)
  311. # We cannot bail depending on the version, as here we only
  312. # know what was the last configured version, and we might
  313. # have been unpacked, then upgraded with an unpack and thus
  314. # never been configured before.
  315. if [ "$1" = "configure" ] &&
  316. [ -d "${PATHNAME}.dpkg-backup" ] &&
  317. [ ! -h "$PATHNAME" ] && [ -d "$PATHNAME" ] &&
  318. [ -f "$PATHNAME/.dpkg-staging-dir" ]; then
  319. finish_dir_to_symlink "$PATHNAME" "$SYMLINK_TARGET"
  320. fi
  321. ;;
  322. postrm)
  323. if [ "$1" = "purge" ] && [ -d "${PATHNAME}.dpkg-backup" ]; then
  324. rm -rf "${PATHNAME}.dpkg-backup"
  325. fi
  326. if [ "$1" = "abort-install" -o "$1" = "abort-upgrade" ] &&
  327. [ -n "$2" ] &&
  328. [ -d "${PATHNAME}.dpkg-backup" ] &&
  329. [ \( ! -h "$PATHNAME" -a -d "$PATHNAME" -a \
  330. -f "$PATHNAME/.dpkg-staging-dir" \) -o \
  331. \( -h "$PATHNAME" -a \
  332. \( "$(readlink $PATHNAME)" = "$SYMLINK_TARGET" -o \
  333. "$(readlink -f $PATHNAME)" = "$SYMLINK_TARGET" \) \) ] &&
  334. dpkg --compare-versions "$2" le-nl "$LASTVERSION"; then
  335. abort_dir_to_symlink "$PATHNAME"
  336. fi
  337. ;;
  338. *)
  339. debug "$0 dir_to_symlink not required in $DPKG_MAINTSCRIPT_NAME"
  340. ;;
  341. esac
  342. }
  343. prepare_dir_to_symlink()
  344. {
  345. local PACKAGE="$1"
  346. local PATHNAME="$2"
  347. # If there are conffiles we should not perform the switch.
  348. if dpkg-query -W -f='${Conffiles}' "$PACKAGE" | \
  349. grep -q "$PATHNAME/."; then
  350. error "directory '$PATHNAME' contains conffiles," \
  351. "cannot switch to symlink"
  352. fi
  353. # If there are locally created files or files owned by another package
  354. # we should not perform the switch.
  355. find "$PATHNAME" -print0 | xargs -0 -n1 sh -c '
  356. package="$1"
  357. file="$2"
  358. if ! dpkg-query -L "$package" | grep -q -x "$file"; then
  359. exit 1
  360. fi
  361. exit 0
  362. ' check-files-ownership "$PACKAGE" || \
  363. error "directory '$PATHNAME' contains files not owned by" \
  364. "package $PACKAGE, cannot switch to symlink"
  365. # At this point, we know that the directory either contains no files,
  366. # or only non-conffiles owned by the package.
  367. #
  368. # To do the switch we cannot simply replace it with the final symlink
  369. # just yet, because dpkg needs to remove any file present in the old
  370. # package that have disappeared in the new one, and we do not want to
  371. # lose files resolving to the same pathname in the symlink target.
  372. #
  373. # We cannot replace the directory with a staging symlink either,
  374. # because dpkg will update symlinks to their new target.
  375. #
  376. # So we need to create a staging directory, to avoid removing files
  377. # from other packages, and to trap any new files in the directory
  378. # to move them to their correct place later on.
  379. mv -f "$PATHNAME" "${PATHNAME}.dpkg-backup"
  380. mkdir "$PATHNAME"
  381. # Mark it as a staging directory, so that we can track things.
  382. touch "$PATHNAME/.dpkg-staging-dir"
  383. }
  384. finish_dir_to_symlink()
  385. {
  386. local PATHNAME="$1"
  387. local SYMLINK_TARGET="$2"
  388. # Move the contents of the staging directory to the symlink target,
  389. # as those are all new files installed between this package being
  390. # unpacked and configured.
  391. local ABS_SYMLINK_TARGET
  392. if [ "${SYMLINK_TARGET#/}" = "$SYMLINK_TARGET" ]; then
  393. ABS_SYMLINK_TARGET="$(dirname "$PATHNAME")/$SYMLINK_TARGET"
  394. else
  395. ABS_SYMLINK_TARGET="$SYMLINK_TARGET"
  396. fi
  397. rm "$PATHNAME/.dpkg-staging-dir"
  398. find "$PATHNAME" -mindepth 1 -print0 | \
  399. xargs -0 -i% mv -f "%" "$ABS_SYMLINK_TARGET/"
  400. # Remove the staging directory.
  401. rmdir "$PATHNAME"
  402. # Do the actual switch.
  403. ln -s "$SYMLINK_TARGET" "$PATHNAME"
  404. # We are left behind the old files owned by this package in the backup
  405. # directory, just remove it.
  406. rm -rf "${PATHNAME}.dpkg-backup"
  407. }
  408. abort_dir_to_symlink()
  409. {
  410. local PATHNAME="$1"
  411. echo "Restoring backup of $PATHNAME ..."
  412. if [ -h "$PATHNAME" ]; then
  413. rm -f "$PATHNAME"
  414. else
  415. # The staging directory must be empty, as no other package
  416. # should have been unpacked inbetween.
  417. rm -f "$PATHNAME/.dpkg-staging-dir"
  418. rmdir "$PATHNAME"
  419. fi
  420. mv "${PATHNAME}.dpkg-backup" "$PATHNAME"
  421. }
  422. # Common functions
  423. ensure_package_owns_file() {
  424. local PACKAGE="$1"
  425. local FILE="$2"
  426. if ! dpkg-query -L "$PACKAGE" | grep -q -x "$FILE"; then
  427. debug "File '$FILE' not owned by package " \
  428. "'$PACKAGE', skipping $command"
  429. return 1
  430. fi
  431. return 0
  432. }
  433. symlink_match()
  434. {
  435. local SYMLINK="$1"
  436. local SYMLINK_TARGET="$2"
  437. [ "$(readlink $SYMLINK)" = "$SYMLINK_TARGET" ] || \
  438. [ "$(readlink -f $SYMLINK)" = "$SYMLINK_TARGET" ]
  439. }
  440. debug() {
  441. if [ -n "$DPKG_DEBUG" ]; then
  442. echo "DEBUG: $PROGNAME: $*" >&2
  443. fi
  444. }
  445. error() {
  446. echo "$PROGNAME: error: $*" >&2
  447. exit 1
  448. }
  449. warning() {
  450. echo "$PROGNAME: warning: $*" >&2
  451. }
  452. usage() {
  453. cat <<END
  454. Usage: $PROGNAME <command> <parameter>... -- <maintainer-script-parameter>...
  455. Commands:
  456. supports <command>
  457. Returns 0 (success) if the given command is supported, 1 otherwise.
  458. rm_conffile <conffile> [<last-version> [<package>]]
  459. Remove obsolete conffile. Must be called in preinst, postinst and
  460. postrm.
  461. mv_conffile <old-conf> <new-conf> [<last-version> [<package>]]
  462. Rename a conffile. Must be called in preinst, postinst and postrm.
  463. symlink_to_dir <pathname> <old-symlink-target> [<last-version> [<package>]]
  464. Replace a symlink with a directory. Must be called in preinst,
  465. postinst and postrm.
  466. dir_to_symlink <pathname> <new-symlink-target> [<last-version> [<package>]]
  467. Replace a directory with a symlink. Must be called in preinst,
  468. postinst and postrm.
  469. help
  470. Display this usage information.
  471. END
  472. }
  473. badusage() {
  474. echo "$PROGNAME: error: $1" >&2
  475. echo >&2
  476. echo "Use '$PROGNAME help' for program usage information." >&2
  477. exit 1
  478. }
  479. # Main code
  480. set -e
  481. PROGNAME=$(basename $0)
  482. version="unknown"
  483. command="$1"
  484. [ $# -gt 0 ] || badusage "missing command"
  485. shift
  486. case "$command" in
  487. supports)
  488. case "$1" in
  489. rm_conffile|mv_conffile|symlink_to_dir|dir_to_symlink)
  490. code=0
  491. ;;
  492. *)
  493. code=1
  494. ;;
  495. esac
  496. if [ -z "$DPKG_MAINTSCRIPT_NAME" ]; then
  497. warning "environment variable DPKG_MAINTSCRIPT_NAME missing"
  498. code=1
  499. fi
  500. if [ -z "$DPKG_MAINTSCRIPT_PACKAGE" ]; then
  501. warning "environment variable DPKG_MAINTSCRIPT_PACKAGE missing"
  502. code=1
  503. fi
  504. exit $code
  505. ;;
  506. rm_conffile)
  507. rm_conffile "$@"
  508. ;;
  509. mv_conffile)
  510. mv_conffile "$@"
  511. ;;
  512. symlink_to_dir)
  513. symlink_to_dir "$@"
  514. ;;
  515. dir_to_symlink)
  516. dir_to_symlink "$@"
  517. ;;
  518. --help|help|-?)
  519. usage
  520. ;;
  521. --version)
  522. cat <<-END
  523. Debian $PROGNAME version $version.
  524. This is free software; see the GNU General Public License version 2 or
  525. later for copying conditions. There is NO warranty.
  526. END
  527. ;;
  528. *)
  529. badusage "command $command is unknown
  530. Hint: upgrading dpkg to a newer version might help."
  531. esac
  532. exit 0